config/routes.rb
Rails.application.routes.draw do
  root 'learning_resources#index'  
  resources :quiz_transactions
  resources :learning_resource_transactions
  resources :quiz_questions
  resources :learning_resources
  devise_for :users

  resources :quizzes do
    resources :questions
  end

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  
  # Defines the root path route ("/")
  # root "posts#index"
end

app/controllers/quizzes_controller.rb
class QuizzesController < ApplicationController
  before_action :set_quiz, only: %i[ show edit update destroy ]

  # GET /quizzes or /quizzes.json
  def index
    @quizzes = Quiz.all
  end

  # GET /quizzes/1 or /quizzes/1.json
  def show
    @quiz = Quiz.find(params[:id])
  end

  # GET /quizzes/new
  def new
    @quiz = Quiz.new
  end

  # GET /quizzes/1/edit
  def edit
  end

  # POST /quizzes or /quizzes.json
  def create
    @quiz = Quiz.new(quiz_params)

    respond_to do |format|
      if @quiz.save
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully created." }
        format.json { render :show, status: :created, location: @quiz }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /quizzes/1 or /quizzes/1.json
  def update
    respond_to do |format|
      if @quiz.update(quiz_params)
        format.html { redirect_to quiz_url(@quiz), notice: "Quiz was successfully updated." }
        format.json { render :show, status: :ok, location: @quiz }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @quiz.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /quizzes/1 or /quizzes/1.json
  def destroy
    @quiz.destroy!

    respond_to do |format|
      format.html { redirect_to quizzes_url, notice: "Quiz was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_quiz
      @quiz = Quiz.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def quiz_params
      params.require(:quiz).permit(:title, :question1, :anstext1, :anstext_boolean11, :anstext_boolean12, :anstext_boolean13, :question2, :anstext2, :anstext_boolean21, :anstext_boolean22, :anstext_boolean23, :question3, :anstext3, :anstext_boolean31, :anstext_boolean32, :anstext_boolean33, :question4, :anstext4, :anstext_boolean41, :anstext_boolean42, :anstext_boolean43, :question5, :anstext5, :anstext_boolean51, :anstext_boolean52, :anstext_boolean53, :question6, :anstext6, :anstext_boolean61, :anstext_boolean62, :anstext_boolean63)
    end
end

app/helpers/quizzes_helper.rb
module QuizzesHelper
end

app/views/quizzes/_form.html.erb
<%= form_with(model: quiz) do |form| %>
  <% if quiz.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(quiz.errors.count, "error") %> prohibited this quiz from being saved:</h2>

      <ul>
        <% quiz.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :title, style: "display: block" %>
    <%= form.text_field :title %>
  </div>

  <% (1..6).each do |i| %>
    <div>
      <%= form.label "question#{i}", style: "display: block" %>
      <%= form.text_field "question#{i}" %>
    </div>

    <div>
      <%= form.label "anstext#{i}", style: "display: block" %>
      <%= form.text_field "anstext#{i}" %>
    </div>

    <div>
      <%= form.label "answer#{i}_option", style: "display: block" %>
      <%= form.radio_button "answer#{i}_option", 'Option 1' %>
      <%= form.label "answer#{i}_option", 'Option 1' %>
      <%= form.radio_button "answer#{i}_option", 'Option 2' %>
      <%= form.label "answer#{i}_option", 'Option 2' %>
      <%= form.radio_button "answer#{i}_option", 'Option 3' %>
      <%= form.label "answer#{i}_option", 'Option 3' %>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/quizzes/_quiz.html.erb
<div id="<%= dom_id quiz %>">
  <p>
    <strong>Title:</strong>
    <%= quiz.title %>
  </p>

  <p>
    <strong>Question1:</strong>
    <%= quiz.question1 %>
  </p>

  <p>
    <strong>Anstext1:</strong>
    <%= quiz.anstext1 %>
  </p>

  <p>
    <strong>Anstext boolean11:</strong>
    <%= quiz.anstext_boolean11 %>
  </p>

  <p>
    <strong>Anstext boolean12:</strong>
    <%= quiz.anstext_boolean12 %>
  </p>

  <p>
    <strong>Anstext boolean13:</strong>
    <%= quiz.anstext_boolean13 %>
  </p>

  <p>
    <strong>Question2:</strong>
    <%= quiz.question2 %>
  </p>

  <p>
    <strong>Anstext2:</strong>
    <%= quiz.anstext2 %>
  </p>

  <p>
    <strong>Anstext boolean21:</strong>
    <%= quiz.anstext_boolean21 %>
  </p>

  <p>
    <strong>Anstext boolean22:</strong>
    <%= quiz.anstext_boolean22 %>
  </p>

  <p>
    <strong>Anstext boolean23:</strong>
    <%= quiz.anstext_boolean23 %>
  </p>

  <p>
    <strong>Question3:</strong>
    <%= quiz.question3 %>
  </p>

  <p>
    <strong>Anstext3:</strong>
    <%= quiz.anstext3 %>
  </p>

  <p>
    <strong>Anstext boolean31:</strong>
    <%= quiz.anstext_boolean31 %>
  </p>

  <p>
    <strong>Anstext boolean32:</strong>
    <%= quiz.anstext_boolean32 %>
  </p>

  <p>
    <strong>Anstext boolean33:</strong>
    <%= quiz.anstext_boolean33 %>
  </p>

  <p>
    <strong>Question4:</strong>
    <%= quiz.question4 %>
  </p>

  <p>
    <strong>Anstext4:</strong>
    <%= quiz.anstext4 %>
  </p>

  <p>
    <strong>Anstext boolean41:</strong>
    <%= quiz.anstext_boolean41 %>
  </p>

  <p>
    <strong>Anstext boolean42:</strong>
    <%= quiz.anstext_boolean42 %>
  </p>

  <p>
    <strong>Anstext boolean43:</strong>
    <%= quiz.anstext_boolean43 %>
  </p>

  <p>
    <strong>Question5:</strong>
    <%= quiz.question5 %>
  </p>

  <p>
    <strong>Anstext5:</strong>
    <%= quiz.anstext5 %>
  </p>

  <p>
    <strong>Anstext boolean51:</strong>
    <%= quiz.anstext_boolean51 %>
  </p>

  <p>
    <strong>Anstext boolean52:</strong>
    <%= quiz.anstext_boolean52 %>
  </p>

  <p>
    <strong>Anstext boolean53:</strong>
    <%= quiz.anstext_boolean53 %>
  </p>

  <p>
    <strong>Question6:</strong>
    <%= quiz.question6 %>
  </p>

  <p>
    <strong>Anstext6:</strong>
    <%= quiz.anstext6 %>
  </p>

  <p>
    <strong>Anstext boolean61:</strong>
    <%= quiz.anstext_boolean61 %>
  </p>

  <p>
    <strong>Anstext boolean62:</strong>
    <%= quiz.anstext_boolean62 %>
  </p>

  <p>
    <strong>Anstext boolean63:</strong>
    <%= quiz.anstext_boolean63 %>
  </p>

</div>

app/views/quizzes/edit.html.erb
<h1>Editing quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Show this quiz", @quiz %> |
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Quizzes</h1>

<div id="quizzes">
  <% @quizzes.each do |quiz| %>
    <p>
      <%= link_to quiz.title, quiz %>
    </p>
  <% end %>
</div>

<%= link_to "New quiz", new_quiz_path %>

app/views/quizzes/new.html.erb
<h1>New quiz</h1>

<%= render "form", quiz: @quiz %>

<br>

<div>
  <%= link_to "Back to quizzes", quizzes_path %>
</div>

app/views/quizzes/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @quiz %>

<div>
  <%= link_to "Edit this quiz", edit_quiz_path(@quiz) %> |
  <%= link_to "Back to quizzes", quizzes_path %>

  <%= button_to "Destroy this quiz", @quiz, method: :delete %>
</div>